DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION > Class Template Reference

, More...

`#include <dh.h>`

Inheritance diagram for DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >:

## Public Types

typedef GROUP_PARAMETERS | GroupParameters
typedef GroupParameters::Element | Element
typedef DL_KeyAgreementAlgorithm_DH< Element, COFACTOR_OPTION > | DH_Algorithm
typedef DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION > | Domain

## Public Member Functions

| DH_Domain (const GroupParameters &params)
| DH_Domain (BufferedTransformation &bt)
template<class T2 >
| DH_Domain (RandomNumberGenerator &v1, const T2 &v2)
template<class T2 , class T3 >
| DH_Domain (RandomNumberGenerator &v1, const T2 &v2, const T3 &v3)
template<class T2 , class T3 , class T4 >
| DH_Domain (RandomNumberGenerator &v1, const T2 &v2, const T3 &v3, const T4 &v4)
template<class T1 , class T2 >
| DH_Domain (const T1 &v1, const T2 &v2)
template<class T1 , class T2 , class T3 >
| DH_Domain (const T1 &v1, const T2 &v2, const T3 &v3)
template<class T1 , class T2 , class T3 , class T4 >
| DH_Domain (const T1 &v1, const T2 &v2, const T3 &v3, const T4 &v4)
const GroupParameters & | GetGroupParameters () const
GroupParameters & | AccessGroupParameters ()
void | GeneratePublicKey (RandomNumberGenerator &rng, const byte *privateKey, byte *publicKey) const
| generate public key More...
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
CryptoParameters & | AccessCryptoParameters ()
unsigned int | AgreedValueLength () const
| return length of agreed value produced
unsigned int | PrivateKeyLength () const
| return length of private keys in this domain
unsigned int | PublicKeyLength () const
| return length of public keys in this domain
void | GeneratePrivateKey (RandomNumberGenerator &rng, byte *privateKey) const
| generate private key More...
bool | Agree (byte *agreedValue, const byte *privateKey, const byte *otherPublicKey, bool validateOtherPublicKey=true) const
| derive agreed value from your private key and couterparty's public key, return false in case of failure More...
const Element & | GetGenerator () const
virtual void | GenerateKeyPair (RandomNumberGenerator &rng, byte *privateKey, byte *publicKey) const
| generate private/public key pair More...
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual const CryptoParameters & | GetCryptoParameters () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Member Functions

const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const

## Detailed Description

### template<class GROUP_PARAMETERS, class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>
class DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >

,

Definition at line 13 of file dh.h.

## Member Function Documentation

template<class GROUP_PARAMETERS , class COFACTOR_OPTION = typename GROUP_PARAMETERS::DefaultCofactorOption>

void DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >::GeneratePublicKey | ( | RandomNumberGenerator & | rng,
|  | const byte * | privateKey,
|  | byte * | publicKey
| ) |  | const

inline virtual

generate public key

Precondition
  size of publicKey == PublicKeyLength()

Implements SimpleKeyAgreementDomain.

Definition at line 58 of file dh.h.

References FIPS_140_2_ComplianceEnabled().

void DL_SimpleKeyAgreementDomainBase< GROUP_PARAMETERS::Element >::GeneratePrivateKey | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey
| ) |  | const

inline virtual inherited

generate private key

Precondition
  size of privateKey == PrivateKeyLength()

Implements SimpleKeyAgreementDomain.

Definition at line 1386 of file pubkey.h.

References Integer::Encode(), and Integer::One().

bool DL_SimpleKeyAgreementDomainBase< GROUP_PARAMETERS::Element >::Agree | ( | byte * | agreedValue,
|  | const byte * | privateKey,
|  | const byte * | otherPublicKey,
|  | bool | validateOtherPublicKey = `true`
| ) |  | const

inline virtual inherited

derive agreed value from your private key and couterparty's public key, return false in case of failure

Note
  If you have previously validated the public key, use validateOtherPublicKey=false to save time.

Precondition
  size of agreedValue == AgreedValueLength()
  length of privateKey == PrivateKeyLength()
  length of otherPublicKey == PublicKeyLength()

Implements SimpleKeyAgreementDomain.

Definition at line 1400 of file pubkey.h.

virtual void SimpleKeyAgreementDomain::GenerateKeyPair | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey,
|  | byte * | publicKey
| ) |  | const

virtual inherited

generate private/public key pair

Note
  equivalent to calling GeneratePrivateKey() and then GeneratePublicKey()

The documentation for this class was generated from the following file:

- dh.h